/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*  ======================
		|			GNU TI-Go      |
		======================
		
		version 1.0
		Port by Joseph Marino (jam4@njit.edu)
		
		Things to do:
		-Add automatic endgame scoring.  Manual endgame scoring
		 removed, as I do not believe score to be something the
		 player should have to calculate.
		-Fix save-game code for TI; was getting protected memory
		 violations as it stands.
		-Improve graphical engine. This initial interface is only
		 meant to allow me quick access to Go on my calc. I will
		 make it prettier.
		-Add support for TI92+/V200. Again, I wanted a quick,
		 working version for me to play, so I didn't bother with
		 enforcing compatibility.
*/

/*------------------------------
  main.c -- gnugo main program
------------------------------*/

//#define USE_TI89
#define OPTIMIZE_ROM_CALLS

#include <tigcclib.h>
#include "gnugo.h"

unsigned char p[19][19];  /* go board */
unsigned char l[19][19];  /* liberty of current color */
unsigned char ma[19][19]; /* working matrix for marking */
unsigned char ml[19][19]; /* working matrix for marking */
int mymove, umove;        /* computer color, opponent color */
int lib;                  /* current stone liberty */
int play;                 /* game state */
int pass;                 /* pass indicator */
int mik, mjk;             /* location of computer stone captured */
int uik, ujk;             /* location of opponent stone captured */
int mk, uk;               /* no. of stones captured by computer and oppoent */
int opn[9];               /* opening pattern flag */

int _main()
  {
//   FILE *fp;
   int i, j, m, n;
   char ans[5];
   short key = 0;
   short illegal = 0;
   int cont = 0;
   //time_t tm;


/* show instruction */
   showinst();
	 FontSetSys(F_4x6);
//   if ((fp = fopen("gnugo.dat", "r")) != NULL)  /* continue old game */
//     {
//      cont = 1;

/* read board configuration */
//      for (i = 0; i < 19; i++)
//        for (j = 0; j < 19; j++)
//          fscanf(fp, "%c", &p[i][j]);

/* read my color, pieces captured */
 //     fscanf(fp, "%d %d %d ", &mymove, &mk, &uk);
/* read opening pattern flags */
//      for (i = 0; i < 9; i++)
//        fscanf(fp, "%d ", &opn[i]);

//      fclose(fp);
//      umove = 3 - mymove;

/* delete file */
//      remove("gnugo.dat");
//    }
//   else
//     {
/* init opening pattern numbers to search */
      for (i = 0; i < 9; i++)
        opn[i] = 1;
      opn[4] = 0;

/* init board */
      for (i = 0; i < 19; i++)
        for (j = 0; j < 19; j++)
          p[i][j] = EMPTY;
/* init global variables */
      mk = 0;  uk = 0;
//    }

/* init global variables */
   play = 1;
   pass = 0;
   mik = -1; mjk = -1;
   uik = -1; ujk = -1;
   //srand((unsigned)time(&tm));	/* start random number seed */
   randomize();

//   if (!cont)  /* new game */
//     {
/* ask for handicap */
//      printf("Number of handicap for black (0 to 17)? ");
//      scanf("%d", &i);
//      getchar();
//      sethand(i);

/* display game board */
//      showboard(0,0);

/* choose color */
//      printf("\nChoose side(b or w)? ");
//      scanf("%c",ans);
//      if (ans[0] == 'b')
//        {
         mymove = 1;   /* computer white */
         umove = 2;   /* human black */
//         if (i)
//	   {
//            genmove(&i, &j);   /* computer move */
//            p[i][j] = mymove;
//          }
//       }
//      else
//        {
//         mymove = 2;   /* computer black */
//         umove = 1;   /* human white */
//         if (i == 0)
//	   {
//            genmove(&i, &j);   /* computer move */
//            p[i][j] = mymove;
//          }
//       }
//    }

   i=0;
   j=0;

/* main loop */
   while (play > 0)
     {
     
     	key = 0;
      while(key != KEY_ENTER) {
      	showboard(i, j);
				if(illegal) {
					DrawStr(110, 84, "Illegal Move", A_NORMAL);
					illegal = 0;
				}
      	DrawStr(110, 90, "Your Move", A_NORMAL);
      	key = ngetchx();
      	if((key == KEY_LEFT) && (i>0)) {
      		i--;
      		pass=0;
      	}
      	else if((key == KEY_RIGHT) && (i<18)) {
      		i++;
      		pass=0;
      	}
      	else if((key == KEY_UP) && (j>0)) {
      		j--;
      		pass=0;
      	}
      	else if((key == KEY_DOWN) && (j<18)) {
      		j++;
      		pass=0;
      	}
      	else if(key == KEY_ESC) {
      		play = 0;
      		key = KEY_ENTER;
      	}
//      	else if(key == KEY_F5) {
//					fp = fopen("gnugo.dat", "w");
					/* save board configuration */
//					for (m = 0; m < 19; m++)
//						for (n = 0; n < 19; n++)
//							fprintf(fp, "%c", p[m][n]);
					/* my color, pieces captured */
//					fprintf(fp, "%d %d %d ", mymove, mk, uk);
					/* opening pattern flags */
//					for (m = 0; m < 9; m++)
//						fprintf(fp, "%d ", opn[m]);
					
//					fclose(fp);
//					play = -1;
//					key = KEY_ENTER;
//      	}
      	else if(key == KEY_BACKSPACE) {
      		pass++;
      		i=-1;
      		key = KEY_ENTER;
      	}
      	else if(key == KEY_ENTER) {
      		if ((p[i][j] != EMPTY) || suicide(i, j)) {
      			illegal = 1;
      			pass = 0;
      			key = 0;
      		}
      	}
      }
      	
      if (play > 0) {
			 if (i >= 0)   /* not pass */
	   	 {
	    	 p[i][j] = umove;
	    	 examboard(mymove);	 /* remove my dead pieces */
	  	 }
	 		if (pass != 2)
	   	 {
				 showboard(-1,-1);
				 DrawStr(110, 90, "Thinking...", A_NORMAL);
	    	 genmove(&i, &j);   /* computer move */
	    	 if (i >= 0)   /* not pass */
	       {
	       	 p[i][j] = mymove;
	       	 examboard(umove);   /* remove your dead pieces */
	       }
	     }
	    showboard(-1,-1);
      }
      if (pass == 2) play = 0;	/* both pass then stop game */
    }

 if (play == 0)
   {
/* finish game and count pieces */
    //endgame();
  }

 return 0;
 }  /* end main */
