/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
/*-------------------------------------------------------------
  showbord.c -- Show current go board and playing information
-------------------------------------------------------------*/

#include <tigcclib.h>
#include "gnugo.h"

extern unsigned char p[19][19];   /* go board */
extern int mymove, umove;         /* computer color, opponent color */
extern int mk, uk;    /* no. of stones captured by computer and oppoent */

void showboard(int i, int j)
/* show go board */
{	int x, y;
	char WhiteCap[20], BlackCap[20];

	ClrScr();
	if ((i >= 0) && (j >= 0)) {
		DrawLine(0, (j*5)+2, 96, (j*5)+2, A_NORMAL);
 		DrawLine((i*5)+1, 97, (i*5)+3, 97, A_NORMAL);
  	DrawLine((i*5), 98, (i*5)+4, 98, A_NORMAL);
  
  	DrawLine((i*5)+2, 0, (i*5)+2, 96, A_NORMAL);
  	DrawLine(97, (j*5)+1, 97, (j*5)+3, A_NORMAL);
  	DrawLine(98, (j*5), 98, (j*5)+4, A_NORMAL);
  }
  
	/* p = 0 for empty ,p = 1 for white piece, p = 2 for black piece */
	for (x=2; x<97; x+=5) {
		for (y=2; y<97; y+=5) {
			if (!p[(x-2)/5][(y-2)/5]) {
				DrawPix(x, y, A_NORMAL);
				if (((x==17) || (x==47) || (x==77)) && ((y==17) || (y==47) || (y==77))) {
					DrawPix(x-1, y, A_NORMAL);
					DrawPix(x+1, y, A_NORMAL);
					DrawPix(x, y-1, A_NORMAL);
					DrawPix(x, y+1, A_NORMAL);
				}
			}
			else {
					DrawLine(x-2, y-2, x+2, y-2, A_NORMAL);
					DrawLine(x-2, y+2, x+2, y+2, A_NORMAL);
					DrawLine(x-2, y-2, x-2, y+2, A_NORMAL);
					DrawLine(x+2, y-2, x+2, y+2, A_NORMAL);
					if(p[(x-2)/5][(y-2)/5] == 2) {
						DrawLine(x-1, y-1,x-1,y+1, A_NORMAL);
						DrawLine(x+1, y-1,x+1,y+1, A_NORMAL);
						DrawLine(x,   y-1, x, y+1, A_NORMAL);
					}
					else {
						DrawPix(x,y,A_REVERSE);
						DrawPix(x-1, y, A_REVERSE);
						DrawPix(x+1, y, A_REVERSE);
						DrawPix(x, y-1, A_REVERSE);
						DrawPix(x, y+1, A_REVERSE);
					}	
			}
		}
  }
  
  if (mymove == 1) {
		sprintf(WhiteCap, "White: %i", uk);
		sprintf(BlackCap, "Black: %i", mk);
	}
	else {
		sprintf(WhiteCap, "White: %i", mk);
		sprintf(BlackCap, "Black: %i", uk);
	}
	DrawStr (110, 5, "Captures", A_NORMAL);
	DrawLine(110, 11, 140, 11, A_NORMAL);
	DrawStr (110, 13, BlackCap, A_NORMAL);
	DrawStr (110, 19, WhiteCap, A_NORMAL);
  /* end showboard */
}